#include "FGDependencyDistance.h"

#include <sstream>
#include <assert.h>

using namespace std;

/* Threshold for the token distance within a deependency */
#define EGSTRA_TOKEN_DISTANCE_THRESHOLD 41

namespace egstra {
  void fg_dependency_distance::phi(const sentence* x, list<string> F[],
				   const int word_limit,
				   const bool use_pos) {
    static int thresholds[] = {2, 5, 10, 20, 30, 40};
    const int N = x->size();
    ostringstream os;
    for(int h = 0; h < N; ++h) {
      for(int m = 0; m < N; ++m) {
	/* skip the root dependency */
	if(h == m) { continue; }

	const int dep_idx = h + N*m;
	list<string>& f = F[dep_idx];

	/* the start of the dependency in the sentence */
	const int dist = (m < h ? h - m : m - h);
	/* indicator for the direction of the dependency */
	const int modBefore = (m < h ? 1 : 0);

	/* the length of the path between the two tokens */
	for(unsigned int i = 0; i < sizeof(thresholds); ++i) {
	  const int thresh = thresholds[i];
	  if(dist > thresh) {
	    os.str("");
	    os << "pathlenge:" << modBefore << "+" << thresh;
	    f.push_back(os.str());
	  }
	}
	const int plen = (dist > EGSTRA_TOKEN_DISTANCE_THRESHOLD
			  ? EGSTRA_TOKEN_DISTANCE_THRESHOLD : dist);
	os.str("");
	os << "pathlen:" << modBefore << "+" << plen;
	f.push_back(os.str());
      }
    }
  }
}
