#ifndef EGSTRA_FG_UTIL_H
#define EGSTRA_FG_UTIL_H

/* FGUtil : helper functions for dependency feature generation. */


#include <list>
#include <string>

#include "Token.h"
#include "StringMap.h"

namespace egstra {
  class fg_util {
  private:
    /* mapping from POS tags (coarse and fine) to tag classes */
    static int _ntags;
    static bool* _tag_is_verb;
    static bool* _tag_is_punc;
    static bool* _tag_is_coord;


  public:
    /* create the tag mappings */
    static void load_tag_map(const std::string& path);

    static int ntags() { return _ntags; }

    /* indicators for classes of tokens */
    static bool is_verb(const token& t) {
      return _tag_is_verb[t.coarse_tag()] || _tag_is_verb[t.fine_tag()];
    }
    static bool is_punc(const token& t) {
      return _tag_is_punc[t.coarse_tag()] || _tag_is_punc[t.fine_tag()];
    }
    static bool is_coord(const token& t) {
      return _tag_is_coord[t.coarse_tag()] || _tag_is_coord[t.fine_tag()];
    }
  };
}

#endif /* EGSTRA_FG_UTIL_H */
