/* Pattern : abstract class representing a pattern to be classified

   This class may be defined arbitrarily, but it must maintain proper
   values for size and nparts.  The former should be a measure of the
   size of the pattern, and the latter should give the number of
   possible parts in this pattern.

   Author : Terry Koo
            maestro@csail.mit.edu */

#ifndef EGSTRA_PATTERN_H
#define EGSTRA_PATTERN_H

#include "Label.h"

#include <stdio.h>

namespace egstra {
  class pattern {
  private:
    int _id;
    int _size;
    int _nparts;

  public:
    pattern() : _id(-1), _size(-1), _nparts(-1) {}
    virtual ~pattern() {}

    void set_id(const int i)     { _id = i; }
    void set_size(const int i)   { _size = i; }
    void set_nparts(const int i) { _nparts = i; }

    int id() const     { return _id; }
    int size() const   { return _size; }
    int nparts() const { return _nparts; }
  };
}

#endif /* EGSTRA_PATTERN_H */
