#include "LLSGDTrainer.h"

#include "SGDTrainer.h"
#include "ObjectiveFunction.h"

using namespace std;

namespace egstra {
  llsgd_trainer::llsgd_trainer()
    : trainer(), _impl(new sgd_trainer<obj_loglinear>())
  {}

  llsgd_trainer::~llsgd_trainer() {
    delete _impl;
  }

  void llsgd_trainer::usage(const char* const mesg) {
    assert(_impl != NULL);
    _impl->usage(mesg);
  }

  void llsgd_trainer::process_options() {
    assert(_impl != NULL);
    _impl->process_options();
  }

  void llsgd_trainer::train(dataset& trdata, dataset& valdata,
			    const int T) {
    assert(_impl != NULL);
    _impl->set_model(_M);
    _impl->set_fgen(_fg);
    _impl->set_dir(_dir);
    _impl->train(trdata, valdata, T);
  }
}
