#include "NullTrainer.h"

#include "Timer.h"

#include <stdlib.h>
#include <iostream>

using namespace std;

namespace egstra {
  void null_trainer::usage(const char* const mesg) {
    cerr << "NullTrainer has no options" << endl;
  }

  void null_trainer::process_options() {}

  void null_trainer::train(dataset& trdata, dataset& valdata,
			    const int T) {
    cerr << "NullTrainer : generating features " << flush;
    timer_start();
    const int Ntr = trdata.size();
    for(int i = 0; i < Ntr; ++i) {
      const example* const ex = trdata[i];
      _fg->phi(ex->x());
      ticker(i + 1, Ntr);
    }
    ticker(Ntr, Ntr);
    timer_stop();
    cerr << " [" << timestr(timediff) << "]" << endl;
  }
}
