/************************************************************
 *
 *   Author : Terry Koo
 *            maestro@csail.mit.edu
 *
 *   NullTrainer : A trainer that just goes through all the
 *                 training data and generates features, e.g.
 *                 for feature-dictionary generation.
 *
 ************************************************************/
#ifndef EGSTRA_NULLTRAINER_H
#define EGSTRA_NULLTRAINER_H

#include "Trainer.h"
#include "Register.h"

namespace egstra {

  class null_trainer : public trainer {
  public:
    null_trainer() : trainer() {}
    ~null_trainer() {}

    void usage(const char* const mesg = "");
    void process_options();

    void train(dataset& trdata, dataset& valdata, const int T);

  };

  REGISTER_TRAINER(null, null_trainer);
}


#endif /* EGSTRA_NULLTRAINER_H */
