#ifndef EGSTRA_REGISTER_H
#define EGSTRA_REGISTER_H

#include "Registry.h"

/* Use these macros to register your objects */
#define REGISTER_TRAINER(name, object)		\
  REGISTER(trainer, name, object)
#define REGISTER_FGEN(name, object)		\
  REGISTER(fgen, name, object)
#define REGISTER_MODEL(name, object)		\
  REGISTER(model, name, object)

/* Underlying macro that actually registers an object.  There are two
   steps to the registratio process.

   1. Create a wrapper function that constructs the desired object.

   2. In order to get the register::add() function to be called,
      instantiate a single registry object at global scope.  Thus, at
      program initialization, the object and constructor will be
      registered. */
#define REGISTER(type, name, object)				\
  void*								\
  make_ ## type ## _ ## name() {				\
    return new egstra::object();					\
  }								\
  egstra::registry						\
  reg_ ## type ## _ ## name(#type,				\
			    #name,				\
			    make_ ## type ## _ ## name)

#endif /* EGSTRA_REGISTER_H */
